static const char *RcsId = "$Header: /users/chaize/newsvn/cvsroot/Instrumentation/Interlock/Daresbury/DaresburyV4/Daresbury.cpp,v 1.2 2005-01-25 17:10:30 jlpons Exp $";
//+=============================================================================
//
// file :         Daresbury.cpp
//
// description :  C++ source for the Daresbury and its commands. 
//                The class is derived from Device. It represents the
//                CORBA servant object which will be accessed from the
//                network. All commands which can be executed on the
//                Daresbury are implemented in this file.
//
// project :      TANGO Device Server
//
// $Author: jlpons $
//
// $Revision: 1.2 $
//
// $Log: not supported by cvs2svn $
// Revision 1.1  2004/11/09 16:05:06  jlpons
// Added interlock directory
//
//
// copyleft :     European Synchrotron Radiation Facility
//                BP 220, Grenoble 38043
//                FRANCE
//
//-=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================


//===================================================================
//
//	The folowing table gives the correspondance
//	between commands and method's name.
//
//	Command's name	|	Method's name
//	----------------------------------------
//	State	|	dev_state()
//	Status	|	dev_status()
//	Reset	|	reset()
//	GetInterlockDescription	|	get_interlock_description()
//	SetInterlockDescription	|	set_interlock_description()
//	GetHistoryInfo	|	get_history_info()
//	ReadInterlockHistory	|	read_interlock_history()
//	GetAllDescription	|	get_all_description()
//	ReadSerial	|	read_serial()
//
//===================================================================

#include <tango.h>
#include <Daresbury.h>
#include <Serial.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

#ifndef WIN32
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/time.h>
#endif

// -- Daresbury serial protocol --

#define	READ_STATE	"ST 0\x0d"
#define RESET		"RS 0\x0d"
#define PSCOMS		"Pscoms\x0d"
#define PROCS		"PROCS\x0d"

namespace Daresbury
{

//+----------------------------------------------------------------------------
//
// method : 		Daresbury::Daresbury(string &s)
// 
// description : 	constructor for simulated Daresbury
//
// in : - cl : Pointer to the DeviceClass object
//      - s : Device name 
//
//-----------------------------------------------------------------------------
Daresbury::Daresbury(Tango::DeviceClass *cl,string &s):Tango::Device_2Impl(cl,s.c_str())
{
	init_device();
}

Daresbury::Daresbury(Tango::DeviceClass *cl,const char *s):Tango::Device_2Impl(cl,s)
{
	init_device();
}

Daresbury::Daresbury(Tango::DeviceClass *cl,const char *s,const char *d)
:Tango::Device_2Impl(cl,s,d)
{
	init_device();
}
//+----------------------------------------------------------------------------
//
// method : 		Daresbury::delete_device()
// 
// description : 	will be called at device destruction or at init command.
//
//-----------------------------------------------------------------------------
void Daresbury::delete_device()
{
	//	Delete device's allocated object
	nb_log = 0;
	delete logs;
	delete attr_interlocks_read;
	delete theSerial;
}

//+----------------------------------------------------------------------------
//
// method : 		Daresbury::init_device()
// 
// description : 	will be called at device initialization.
//
//-----------------------------------------------------------------------------
void Daresbury::init_device()
{
	INFO_STREAM << "Daresbury::Daresbury() create device " << device_name << endl;

	// Initialise variables to default values
	//--------------------------------------------
	get_device_property();

	// Create handle to the serial line
	try {
	
	  theSerial = new Tango::DeviceProxy(serial_line);
	
	} catch(Tango::DevFailed &e) {
	
      cerr << "ERROR: cannot import " << serial_line << endl << e.errors[0].desc.in() << endl;
	  exit(0);
	   
	}
	
	start_time = time(NULL);
	
	// Initialise the serial
	initialise_pscom();
	
	// Create interlock image	
	attr_interlocks_read = new short[MAX_MODS];
	logs                 = new ItlkLog[MAX_LOG];
	nb_log               = 0;
	
	// init default
	set_state(Tango::ON);
    set_status("The device is working properly.");
	memset(descriptions,0,sizeof(char *)*MAX_MODS*8);
	for(int i=0;i<MAX_MODS;i++) load_descriptions(i);
	
}


//+----------------------------------------------------------------------------
//
// method : 		Daresbury::readDeviceProperies()
// 
// description : 	Read the device properties from database.
//
//-----------------------------------------------------------------------------
void Daresbury::get_device_property()
{
	//	Initialize your default values here.
	//------------------------------------------
	init_pscom=0;

	//	Read device properties from database.(Automatic code generation)
	//-------------------------------------------------------------
	Tango::DbData	data;
	data.push_back(Tango::DbDatum("Serial_line"));
	data.push_back(Tango::DbDatum("Init_pscom"));

	//	Call database and extract values
	//--------------------------------------------
	get_db_device()->get_property(data);
	if (data[0].is_empty()==false)	data[0]  >>  serial_line;
	if (data[1].is_empty()==false)	data[1]  >>  init_pscom;


	//	End of Automatic code generation
	//-------------------------------------------------------------

}

//+----------------------------------------------------------------------------
//
// method : 		Daresbury::always_executed_hook()
// 
// description : 	method always executed before any command is executed
//
//-----------------------------------------------------------------------------
void Daresbury::always_executed_hook()
{
  
}

//+----------------------------------------------------------------------------
//
// method : 		Daresbury::read_attr_hardware()
// 
// description : 	Hardware acquisition for attributes.
//
//-----------------------------------------------------------------------------
void Daresbury::read_attr_hardware(vector<long> &attr_list)
{
   DEBUG_STREAM << "In read_attr_hardware for " << attr_list.size();
   DEBUG_STREAM << " attribute(s)" << endl;
	
   //	Add your own code here
   //---------------------------------
   
   char *read_argout;
   char  status[4096];   
   int   module,k,rs;
   unsigned short relay_state;
   unsigned short RelayState[MAX_MODS*4];
   
	
   /* Read interlock via serial line */
   
   try {
     send_cmd(READ_STATE,&read_argout);
   } catch(Tango::DevFailed &e) {
     sprintf(status,"No answer from controller (serial %s)\n",serial_line.c_str());
     strcat(status,e.errors[0].desc);
     set_status(status);
     set_state(Tango::UNKNOWN);
     return;
   }
   
   /* Check CC */
   
   read_argout=read_argout+6;
   if(read_argout[0] != '0' && read_argout[1] != '0')
   {
     sprintf(status,"Error on controller, unexpected answer \n");
     set_status(status);
     set_state(Tango::UNKNOWN);
     return;
   }
   
   /* Parse interlock */
   
   read_argout=read_argout+6;
   for(k=0,module=0;module<MAX_MODS;module++)
   {
   
     sscanf(&(read_argout[k]),"%x",&rs);
     relay_state = (unsigned short)rs;
     
     RelayState[module*4+0] = (relay_state & 0x000F);
     RelayState[module*4+1] = (relay_state & 0x00F0) >> 4;
     RelayState[module*4+2] = (relay_state & 0x0F00) >> 8;
     RelayState[module*4+3] = (relay_state & 0xF000) >> 12;
     
     attr_interlocks_read[module] = compact_state(RelayState[module*4+0])    +
                                    compact_state(RelayState[module*4+1])*4  +
                                    compact_state(RelayState[module*4+2])*16 +
                                    compact_state(RelayState[module*4+3])*64 ;
				     
     k+=8;
   }
   
   set_state(Tango::ON);
   set_status("The device is working properly.");

}

/*------------------------------------------------------------------*/

short Daresbury::compact_state(short state) {

  // According to the Daresbury PSS relay logic
  
  switch( state ) {
  
    case 0xF: // A and B closed
      return 3;
      break;
    case 0xA: // A open B closed
      return 2;
      break;
    case 0x5: // A closed B open
      return 1;
      break;
    case 0x0: // A and B open
      return 0;
      break;
  
  }

}

//+----------------------------------------------------------------------------
//
// method : 		Daresbury::read_attr()
// 
// description : 	Extract real attribute values from
//					hardware acquisition result.
//
//-----------------------------------------------------------------------------
void Daresbury::read_attr(Tango::Attribute &attr)
{
	string &attr_name = attr.get_name();

	DEBUG_STREAM << "In read_attr for attribute " << attr_name << endl;

	//	Switch on attribute name
	//---------------------------------
	if (attr_name == "interlocks")
	{
	  //	Add your own code here
	  if( get_state()==Tango::ON ) {
        attr.set_value(attr_interlocks_read , MAX_MODS);
	  } else {
        Tango::Except::throw_exception(
      	  (const char *)"Daresbury::error_read",
       	  (const char *)get_status().c_str(),
       	  (const char *)"Daresbury::read_attr(interlocks)");
		
	  }
	}
	
}

//+------------------------------------------------------------------
/**
 *	method:	Daresbury::reset
 *
 *	description:	method to execute "Reset"
 *	Reset the interlock system
 *
 *
 */
//+------------------------------------------------------------------
void Daresbury::reset()
{
  DEBUG_STREAM << "Daresbury::reset(): entering... !" << endl;

  //	Add your own code to control device here
	
  if( nb_log>=MAX_LOG ) {
  
    // shift history
    for(int i=0;i<MAX_LOG-1;i++)
      logs[i] = logs[i+1];
      
  } else {
  
    nb_log++;
    
  }
  
  // Backup last state of relay
  
  logs[nb_log-1].log_time = time(NULL);  
  memcpy(logs[nb_log-1].itlk,attr_interlocks_read,MAX_MODS*sizeof(short));
   
  // Now reset
  
  send_cmd(RESET,NULL);
  	
}

//+------------------------------------------------------------------
/**
 *	method:	Daresbury::get_interlock_description
 *
 *	description:	method to execute "GetInterlockDescription"
 *	Return description of specified interlocks.
 *	
 *	argin[0] = Word address (Itlk 1)
 *	argin[1] = Bit address (Itlk 1)
 *	
 *	argin[2n] = Word address (itlk n)
 *	argin[2n+1] = Bit address (itlk n)
 *	
 *	argout[0] = Itlk description 1
 *	argout[n] = Itlk description n
 *
 * @param	argin	List of Interlock address [Word address , Bit address]*
 * @return	Interlock descrition array
 *
 */
//+------------------------------------------------------------------
Tango::DevVarStringArray *Daresbury::get_interlock_description(const Tango::DevVarLongArray *argin)
{
	//	POGO has generated a method core with argout allocation.
	//	If you would like to use a static reference without copying,
	//	See "TANGO Device Server Programmer's Manual"
	//		(chapter : Writing a TANGO DS / Exchanging data)
	//------------------------------------------------------------
	Tango::DevVarStringArray	*argout  = new Tango::DevVarStringArray();
	DEBUG_STREAM << "Daresbury::get_interlock_description(): entering... !" << endl;

	//	Add your own code to control device here
	int i;
    char tmp[128];
	
	if( argin->length()%2 != 0 ) {
	
           Tango::Except::throw_exception(
              (const char *)"Daresbury::error_badparam",
              (const char *)"Invalid argin (must be a list a couple word address,bit address)",
              (const char *)"Daresbury::get_interlock_description");
	      
	}
	
	argout->length(argin->length()/2);
	
	for(i=0;i<argin->length();i+=2) {

	  int add = (*argin)[i]*8 + (*argin)[i+1];

	  if( add<0 || add>=MAX_MODS*8 ) {

	     sprintf(tmp,"Invalid interlock address at position ",i);
             Tango::Except::throw_exception(
        	  (const char *)"Daresbury::error_read",
        	  (const char *)tmp,
        	  (const char *)"Daresbury::get_interlock_description");
		  
	  }
	  
	  if( descriptions[add] ) 
	    (*argout)[i/2] = CORBA::string_dup(descriptions[add]);	
	  else
	    (*argout)[i/2] = CORBA::string_dup("No description");
	  
	}
		
	return argout;
}

//+------------------------------------------------------------------
/**
 *	method:	Daresbury::get_all_description
 *
 *	description:	method to execute "GetAllDescription"
 *	Returns a list of all description.
 *
 * @return	List of interlock description
 *
 */
//+------------------------------------------------------------------
Tango::DevVarStringArray *Daresbury::get_all_description()
{
	//	POGO has generated a method core with argout allocation.
	//	If you would like to use a static reference without copying,
	//	See "TANGO Device Server Programmer's Manual"
	//		(chapter : Writing a TANGO DS / Exchanging data)
	//------------------------------------------------------------
	Tango::DevVarStringArray	*argout  = new Tango::DevVarStringArray();
	argout->length(MAX_MODS*8);
	DEBUG_STREAM << "Daresbury::get_all_description(): entering... !" << endl;

	//	Add your own code to control device here
	int add;
	for(int i=0;i<MAX_MODS;i++) {
	  for(int j=0;j<8;j++) {

 	    add = i*8 + j;
	    if( descriptions[add] ) 
	      (*argout)[add] = CORBA::string_dup(descriptions[add]);	
	    else
	      (*argout)[add] = CORBA::string_dup("No description");
	      
	  }
	}
	
	return argout;
}

//+------------------------------------------------------------------
/**
 *	method:	Daresbury::set_interlock_description
 *
 *	description:	method to execute "SetInterlockDescription"
 *	Sets the descripton of the specified interlock
 *
 * @param	argin	argin[0]=Word address argin[1]=Bit address argin[2]=Interlock description
 *
 */
//+------------------------------------------------------------------
void Daresbury::set_interlock_description(const Tango::DevVarStringArray *argin)
{
	DEBUG_STREAM << "Daresbury::set_interlock_description(): entering... !" << endl;

	//	Add your own code to control device here
	if( argin->length() != 3 ) {
	
           Tango::Except::throw_exception(
              (const char *)"Daresbury::error_set",
              (const char *)"Invalid argin: 2 values word address,bit address and 1 string expected.",
              (const char *)"Daresbury::set_interlock_description");
	}
	
	int wadd = atoi((*argin)[0]);
	int badd = atoi((*argin)[1]);
	int add = wadd*8 + badd;

	if( add<0 || add>=MAX_MODS*8 ) {

             Tango::Except::throw_exception(
        	  (const char *)"Daresbury::error_badparam",
        	  (const char *)"Invalid interlock address.",
        	  (const char *)"Daresbury::set_interlock_description");
		  
	}
	
	if( descriptions[add] ) 
	  free(descriptions[add]);
	
	descriptions[add] = strdup((*argin)[2]);
	save_description(wadd,badd);

}

//+------------------------------------------------------------------
/**
 *	method:	Daresbury::get_history_info
 *
 *	description:	method to execute "GetHistoryInfo"
 *	Returns a list of known logs.
 *
 * @return	Return a list of interlock logs ,by date)
 *
 */
//+------------------------------------------------------------------
Tango::DevVarLongArray *Daresbury::get_history_info()
{
	//	POGO has generated a method core with argout allocation.
	//	If you would like to use a static reference without copying,
	//	See "TANGO Device Server Programmer's Manual"
	//		(chapter : Writing a TANGO DS / Exchanging data)
	//------------------------------------------------------------
	Tango::DevVarLongArray	*argout  = new Tango::DevVarLongArray();
	DEBUG_STREAM << "Daresbury::get_history_info(): entering... !" << endl;

	//	Add your own code to control device here
	argout->length(nb_log);

	for(int i=0;i<nb_log;i++)
	  (*argout)[i] = logs[i].log_time;

	return argout;
}

//+------------------------------------------------------------------
/**
 *	method:	Daresbury::read_interlock_history
 *
 *	description:	method to execute "ReadInterlockHistory"
 *	Returns the states of the interlock set of the specified log
 *
 * @param	argin	Log time , see GetHistoryInfo )
 * @return	Array of interlock
 *
 */
//+------------------------------------------------------------------
Tango::DevVarShortArray *Daresbury::read_interlock_history(Tango::DevLong argin)
{
	//	POGO has generated a method core with argout allocation.
	//	If you would like to use a static reference without copying,
	//	See "TANGO Device Server Programmer's Manual"
	//		(chapter : Writing a TANGO DS / Exchanging data)
	//------------------------------------------------------------
	Tango::DevVarShortArray	*argout  = new Tango::DevVarShortArray();
	argout->length(MAX_MODS);
	DEBUG_STREAM << "Daresbury::read_interlock_history(): entering... !" << endl;

	//	Add your own code to control device here
	if( nb_log == 0 ) {
	
          Tango::Except::throw_exception(
        	  (const char *)"Daresbury::error_read",
        	  (const char *)"No history available.",
        	  (const char *)"Daresbury::read_interlock_history");
		  
	}
	
	int idx=0;
	int found=0;
	
	while(idx<nb_log && !found) {
	  found = (logs[idx].log_time==argin);
	  if(!found) idx++;
	}
	
	if( !found ) {
	
          Tango::Except::throw_exception(
        	  (const char *)"Daresbury::error_read",
        	  (const char *)"No history found at the specified time.",
        	  (const char *)"Daresbury::read_interlock_history");
	
	}
	
	for(int i=0;i<MAX_MODS;i++)
	  (*argout)[i] = logs[idx].itlk[i];

	return argout;
}

/*------------------------------------------------------------------*/

void Daresbury::save_property(char *name,char *value) {

    Tango::DbData	data;
    Tango::DbDatum  d(name);
    d << value;
    data.push_back(d);
    get_db_device()->put_property(data);

}

/*------------------------------------------------------------------*/

void Daresbury::load_descriptions(int address) {

    char tmpName[128];
    int  add = address*8;
    int  bit;
    Tango::DbData   data;
    string read;
    
    for(bit=0;bit<8;bit++) {
      sprintf(tmpName,"description.%d.%d",address,bit);
      data.push_back(Tango::DbDatum(tmpName));
    }
    
    get_db_device()->get_property(data);
    
    for(bit=0;bit<8;bit++) {
      if (data[bit].is_empty()==false)	{
        data[bit]  >>  read;
  	    descriptions[add+bit]=strdup(read.c_str());
      }
    }
    
}

/*------------------------------------------------------------------*/

void Daresbury::save_description(int address,int bit) {
  
  char tmpName[128];
  int  add = address*8 + bit;

  sprintf(tmpName,"description.%d.%d",address,bit);
  
  if( descriptions[add] ) {
    save_property(tmpName,descriptions[add]);
  }
  
}

/*------------------------------------------------------------------*/

void Daresbury::save_descriptions() {

  for(int i=0;i<MAX_MODS;i++) 
    for(int j=0;j<8;j++)
      save_description(i,j);

}

/*------------------------------------------------------------------*/

void Daresbury::msleep(int ms)
{

#ifdef WIN32

    Sleep(ms);

#else    

    struct timespec tsleep;
    tsleep.tv_sec =   ms / 1000;
    tsleep.tv_nsec = (ms % 1000) * 1000000;
    nanosleep(&tsleep, NULL);

#endif

}

/*------------------------------------------------------------------*/

long Daresbury::get_ticks() {

#ifdef WIN32

  return GetTickCount();

#else

  struct timeval tv;
  gettimeofday(&tv,NULL);
  return ( (tv.tv_sec-start_time)*1000 + tv.tv_usec/1000 );

#endif

}

/*------------------------------------------------------------------

 Function:	static write_cmd(ds, argout )

 Description:	Write the command on the serial line, and read the answer.
   	
 Arg(s) In:     char		*cmd;   // Command to execute 
 Arg(s) Out:	char		*argout // Response

--------------------------------------------------------------------- */
void Daresbury::write_cmd(char *cmd, char **argout)
{
  	char	*str=NULL, *str2;
  	static char answer[256]; 
	string reply;

#ifdef PRINT	
	long t0,t1;
	cout << " Daresbury::write_cmd() Sending: " << cmd << endl;
	t0 = get_ticks();
#endif
   	
	answer[0]='\0'; 
	
    /* Flush the serial */ 	
	
	Tango::DeviceData flushMode;
	flushMode << (long)2;
	theSerial->command_inout("DevSerFlush",flushMode);
				
    /* Send the command */ 	
	
	Tango::DeviceData cmdArgin;
	Tango::DeviceData cmdArgout;
	Tango::DeviceData slMode;
	cmdArgin << cmd;
        theSerial->command_inout("DevSerWriteString",cmdArgin);  	
	slMode << (long)SL_LINE;
        cmdArgout = theSerial->command_inout("DevSerReadString",slMode);
	cmdArgout >> reply;
	str = (char *)reply.c_str();
	   
    /* Jump new line */
	
	if(str[0] == '\x0a')  str2=str+1;
	else  	              str2=str;

    /* Handle echo */
	
	if(strcmp(cmd,str2) == 0)
	{
      cmdArgout = theSerial->command_inout("DevSerReadString",slMode);
	  cmdArgout >> reply;
	  str = (char *)reply.c_str();
	}
	
    /* Jump new line */
	
	if(str[0] == '\x0a')  str2=str+1;
	else  	              str2=str;

    /* Get answer */
	
	strcpy(answer,str2);
	*argout=answer;

#ifdef PRINT	
	t1 = get_ticks();
	cout << " Daresbury::write_cmd() Response: " << str2 << endl;
	cout << " Daresbury::write_cmd() Response: " << (t1-t0) << "ms" << endl;		
#endif
	
}

/*------------------------------------------------------------------

 Function:	static long send_cmd(ds, argout, error)

 Description:	Standard piece of code for reading a value: Write the command
		on the serial line, and read the answer check the answer.
   	
 Arg(s) In:	Digitel		ds ;
 		char		*cmd;
 
 Arg(s) Out:	char		*argout ;
		long		*error ;

 returns devstatus

------------------------------------------------------------------*/

void Daresbury::send_cmd(char *cmd, char **argout)
{
  	char	*str=NULL;   			
	write_cmd(cmd,&str);	
	if(strlen(str) > 1)
	{
	  switch(str[0])
	  {
	     case 's':  /* this is the first letter of "shell:" */
	     case '$':
	       cerr << " pscoms apparently dead,restarting.... " << endl;
	       initialise_pscom();			
	  }
	}
	if(argout)
	  *argout=str;
}

//------------------------------------------------------------------

void Daresbury::initialise_pscom() {

    char *test_argout=NULL;
   
	if( init_pscom ) {
      // Kill the pscoms process
      write_cmd("kill 4\x0d",&test_argout);
      msleep(200);
    
      // Restart it.
      write_cmd("Pscoms\x0d",&test_argout);
      msleep(400);    
	}

}

//+------------------------------------------------------------------
/**
 *	method:	Daresbury::read_serial
 *
 *	description:	method to execute "ReadSerial"
 *	Return the string read via the serial line on the controller. Debugging purpose.
 *
 * @return	Raw output of the Daresbury controller
 *
 */
//+------------------------------------------------------------------
Tango::DevString Daresbury::read_serial()
{
	//	POGO has generated a method core with argout allocation.
	//	If you would like to use a static reference without copying,
	//	See "TANGO Device Server Programmer's Manual"
	//		(chapter : Writing a TANGO DS / Exchanging data)
	//------------------------------------------------------------
	Tango::DevString	argout;
	DEBUG_STREAM << "Daresbury::read_serial(): entering... !" << endl;

	//	Add your own code to control device here
	char *read_argout;
    send_cmd(READ_STATE,&read_argout);
	argout = new char[strlen(read_argout)+1];
	strcpy(argout,read_argout);
	return argout;
}

}	//	namespace
